/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#pragma implementation "pattern_tmpl.hxx"

#include "pattern.hxx"

#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>

struct timeval Tbegin;
struct timeval Tend;
struct timeval tt ;

void timeBegin()
{
  gettimeofday(&Tbegin, NULL);
}

void timeEnd()
{
  gettimeofday(&Tend, NULL);
}

double timeDiff()
{
  double res = (Tend.tv_sec - Tbegin.tv_sec) ;
  res += ((float)(Tend.tv_usec)/1000000) - ((float)(Tbegin.tv_usec)/1000000) ;
  return res ;
}

class PATM_Action {
  public :
  int value ;
} ;

int main(int argc, char** argv)
{
  int cpt = 0 ;
  char command[512] ;
  char pattern[512] ;
  char chaine[512] ;
  PATM_Action* action ;
  
  PATM_Automate<PATM_Action> automate ;

  cout << "Commande ? " ;
  cin >> command ;
  while (command[0] != 'q') {
    switch (command[0]) {
    case 'q' :
      exit(1) ;
      break ;
    case 'i' :      
      cout << "Pattern ? " ;
      cin >> pattern ;
      action = new PATM_Action ;
      action->value = cpt++ ;
      automate.insererCle(pattern, action) ;
      break ;
    case 'r' : 
      cout << "\n" << "Chaine ? " ;    
      cin >> chaine ;
      int num = atoi(argv[1]) ;
      timeBegin() ;
      for (int i = 0; i < num; i++) {
	action = automate.rechercher(chaine) ;
      }
      timeEnd() ;
      cout << "Temps de recherche : " << timeDiff() << endl ;
      if (action == NULL) {
	cout << "Chaine introuvable" << endl ;
      } else {
	cout << "\nValeur trouvee : " << action->value << endl ;
      }
      break ;
    }
    cout << "Commande ? " ;
    cin >> command ;
  }
}
